/**
 	========================================================================
 	 * Author: LuGRU
 	 * WebSide: www.lugru.com
 	 * License: http://creativecommons.org/licenses/by-nc-sa/3.0/us/
 	========================================================================
	
	 * [AS3] Slider class
	========================================================================
	
	var s1:Slider = new Slider( posX:Number, posY:Number, w:Number, h:Number, min:Number = 0, max:Number = 100, 
								cVal:Number = 50, triangleH:Number = 20, sText:String = "", isDecimal:Boolean = false,
								deltaScale:Number = 1, precis:Number = 2, isVertical:Boolean = false, rot_angle:Number = 90,
								isMovable:Boolean = true, isScalable:Boolean = true )
	USAGE:
		posX/posY - position relative to parent
		w/h - width and height of slider (keep in mind if you want to create vertical slider h > w, if horizontal w > h)
		min/max - minimum and maximum values of slider. Use range from x - y where x/y is INT value
		cVal - set initial value for slider
		triangleH - sizo of movable triangle
		sText - title of the slider. If empty, text will be not added to slider at all.
		isDecimal - determines if displayed values are in decimal notation or fixed
		deltaScale - scale slider move by MouseWheel, 0 - not move by wheel, "-/+" value change direction 
		precis - if isDecimal is set this param. tells how many numbers after dot are displayed
		isVertical - determines if slider is vertical or horizontal
		rot_angle - rotation angle of slider triangle, apply only to horizontal slider, not implemented full funcionality
					if angle is diffrent then 90
		isMovable/isScalable - tells if slider can be moved or scaled
**/

package
{
	import flash.display.BitmapData;
	import flash.display.Shape;
	import flash.display.Sprite;
	import flash.events.MouseEvent;
	import flash.text.TextField;
	import flash.utils.Dictionary;
	
	public dynamic class Slider extends Sprite
	{		
		private var triangle:Sprite = new Sprite();
		private var tr_movable:Boolean = false;
		private var t_cval:TextField = new TextField();
		
		private var line:Sprite = new Sprite();
		private var line_bg:Sprite = new Sprite();
		private var l_h:Number;
		private var l_w:Number;
		
		private var l_circle:Sprite;
		private var r_circle:Sprite;
		private var t_max_val:TextField = new TextField();
		private var t_title:TextField = new TextField();
		private var scaledWidth:Number;
		private var scaledHeight:Number;		
		private var circle_bmpd:BitmapData;
		private var s_max:Number;
		
		public var curVal:Number;
		private var dic:Dictionary = new Dictionary();
				
		public function Slider( posX:Number, posY:Number, w:Number, h:Number, min:Number = 0, max:Number = 100, 
						cVal:Number = 50, triangleH:Number = 20, sText:String = "", isDecimal:Boolean = false,
						deltaScale:Number = 1, precis:Number = 2, isVertical:Boolean = false, rot_angle:Number = 90,
						isMovable:Boolean = true, isScalable:Boolean = true )
		{			
			if( isDecimal ){
				oneScale = true;
				percentage = false;
			}else{
				oneScale = false;
				percentage = true;
			}
						
			scaledWidth = w;
			scaledHeight = h;
			curVal = cVal;
			s_max = max;
			
			l_h = h;
			l_w = w;

		//main slider LINE
			if( isVertical ){
				line.graphics.beginFill( 0x898989, 1 );
				line.graphics.drawRect( posX-w/2, posY, w, h );
				line.graphics.endFill();
				this.addChild( line );
					
			}else{
				line.graphics.beginFill( 0x898989, 1 );
				line.graphics.drawRect( posX, posY-h/2, w, h );
				line.graphics.endFill();
				this.addChild( line );
			}
				
		//slider line TRIANGLE
			triangle.graphics.beginFill(0x595d6a);
				triangle.graphics.moveTo(triangleH/2, 5);
				triangle.graphics.lineTo(triangleH, triangleH+5);
				triangle.graphics.lineTo(0, triangleH+5);
				triangle.graphics.lineTo(triangleH/2, 5);
				triangle.graphics.endFill();
			if( isVertical ){
				triangle.x = posX + triangleH/2-5;
				triangle.y = ((scaledHeight/100) * cVal) + posY - triangleH/2;
				t_cval.y = triangle.y;
			}else{
				triangle.x = ((scaledWidth/100) * cVal) + posX - triangleH/2;
				t_cval.x = triangle.x;
				triangle.y = posY - triangleH/2;
			}		
				this.addChild( triangle );
			
		//if vertical slider rotate it
			if( isVertical ) triangle.rotation = rot_angle;
			
			line.addEventListener( MouseEvent.CLICK, moveTriangle, false, 0, true );
			line.addEventListener( MouseEvent.MOUSE_WHEEL, moveTriangle, false, 0, true );
			
			line.addEventListener( MouseEvent.ROLL_OVER, moveTriangleBGpaint, false, 0, true );
			line.addEventListener( MouseEvent.ROLL_OUT, moveTriangleBGerase, false, 0, true );
		//mouse click and up and move
			triangle.addEventListener( MouseEvent.MOUSE_DOWN, movableTriang, false, 0, true );							
			triangle.addEventListener( MouseEvent.MOUSE_MOVE, doMoveTriangle, false, 0, true );							
			triangle.addEventListener( MouseEvent.MOUSE_UP, notmovableTriang, false, 0, true );
		//Mouse over and out
			triangle.addEventListener( MouseEvent.ROLL_OVER, overTriangle, false, 0, true );
			triangle.addEventListener( MouseEvent.ROLL_OUT, outTriangle, false, 0, true ); 		
				
				
			
		//slider TEXTs	
		//t_cval - text CURRENT value	
					
			if( isVertical ){
				
				t_cval.text = cVal.toString();
				t_cval.selectable = false;
				t_cval.x = posX + triangleH/2;
				t_cval.y = triangle.y;
				t_cval.width = 35; 
				t_cval.height = 20;
				t_cval.cacheAsBitmap = true;
				this.addChild( t_cval );
				
			}else{
				
				t_cval.text = cVal.toString();
				t_cval.selectable = false;
				t_cval.x = triangle.x;
				t_cval.y = posY + triangleH;
				t_cval.width = 50; 
				t_cval.height = 20;
				t_cval.cacheAsBitmap = true;
				this.addChild( t_cval );
			} 
			
		//tmp value if slider is TO SMALL, triangleH used for spacing between line and circles for MOVE/SCALE
		//additional if's in r_circle listeners can_ScaleSlider/notScalableSlider
			var tmp_triangleH:Number;
			if( triangleH < 20 )
			{ 
				tmp_triangleH = 20;	
			}else{
				tmp_triangleH = triangleH;	
			}	
			
		//t_min_val - text MINIMUM value
				var t_min_val:TextField = new TextField();
			if( isVertical ){
				if( isDecimal ){
					t_min_val.text = (min/100).toString();
				}else{
					t_min_val.text = min.toString();
				}
					t_min_val.x = posX - triangleH;
					t_min_val.y = posY - 25;
					t_min_val.height = 20;
					t_min_val.width = 30;
					t_min_val.selectable = false;
					t_min_val.cacheAsBitmap = true;
				this.addChild( t_min_val );
				
				
			}else{
				
					t_min_val.text = min.toString();
					t_min_val.x = posX - 15;
					t_min_val.y = posY - 25;
					t_min_val.height = 20;
					t_min_val.width = 30;
					t_min_val.selectable = false;
					t_min_val.cacheAsBitmap = true;
				this.addChild( t_min_val );
			}
			
		//t_max_val - text MAXIMUM value	
			if( isVertical ){
				if( isDecimal ){
					t_max_val.text = (max/100).toString();
				}else{
					t_max_val.text = max.toString();
				}
					t_max_val.x = posX - triangleH-10;
					t_max_val.y = posY + h;
					t_max_val.height = 20;
					t_max_val.width = 30;
					t_max_val.selectable = false;
					t_max_val.cacheAsBitmap = true;
				this.addChild( t_max_val );
			}else{
					t_max_val.text = max.toString();
					t_max_val.x = posX + w;
					t_max_val.y = posY - 25;
					t_max_val.height = 20;
					t_max_val.width = 30;
					t_max_val.selectable = false;
					t_max_val.cacheAsBitmap = true;
				this.addChild( t_max_val );
			}
		
			
		//slider Title, if is empty DONT add it to save mem
			if( sText.length ){
				if( isVertical ){
					
						t_title.text = sText;
						t_title.x = posX - triangleH*2;
						t_title.y = posY - triangleH*2;
						t_title.height = 20;
						t_title.width = h;
						t_title.selectable = false;
						t_title.cacheAsBitmap = true;
					this.addChild( t_title );
					
				}else{
						t_title.text = sText;
						t_title.x = posX;
						t_title.y = posY - 25;
						t_title.height = 20;
						t_title.width = w;
						t_title.selectable = false;
						t_title.cacheAsBitmap = true;
					this.addChild( t_title );					
				}
			}			
			
		// left side circle - for MOVE slider
			if( isMovable ){	
					l_circle = new Sprite();
				if( isVertical ){				
					l_circle.graphics.beginFill( 0x474747, 1 );
					l_circle.graphics.drawCircle( posX, posY - tmp_triangleH/2, 5 );
					l_circle.graphics.endFill();
					this.addChild( l_circle );
					
				}else{
									
					l_circle.graphics.beginFill( 0x474747, 1 );
					l_circle.graphics.drawCircle( posX - tmp_triangleH/2, posY, 5 );
					l_circle.graphics.endFill();
					this.addChild( l_circle );
				}
			
			
				l_circle.addEventListener( MouseEvent.MOUSE_DOWN, can_moveSlider, false, 0, true );
				l_circle.addEventListener( MouseEvent.MOUSE_MOVE, moveSlider, false, 0, true );
				l_circle.addEventListener( MouseEvent.MOUSE_UP, notMovableSlider, false, 0, true );
				l_circle.addEventListener( MouseEvent.ROLL_OUT, notMovableSlider, false, 0, true );
				l_circle.addEventListener( MouseEvent.ROLL_OVER, HandSlider, false, 0, true );	
			}
		// right side circle - for SCALE slider	
			if( isScalable ){
					r_circle = new Sprite();
				if( isVertical ){				
					r_circle.graphics.beginFill( 0x474747, 1 );
					r_circle.graphics.drawCircle( posX, posY + h + tmp_triangleH/2, 5 );
					r_circle.graphics.endFill();
					this.addChild( r_circle );	
				}else{
					r_circle.graphics.beginFill( 0x474747, 1 );
					r_circle.graphics.drawCircle( posX + w + tmp_triangleH/2, posY, 5 );
					r_circle.graphics.endFill();
					this.addChild( r_circle );
				}
						
				r_circle.addEventListener( MouseEvent.MOUSE_DOWN, can_ScaleSlider, false, 0, true );
				r_circle.addEventListener( MouseEvent.MOUSE_MOVE, scaleSlider, false, 0, true );
				r_circle.addEventListener( MouseEvent.MOUSE_UP, notScalableSlider, false, 0, true );
				r_circle.addEventListener( MouseEvent.ROLL_OUT, notScalableSlider, false, 0, true );
				r_circle.addEventListener( MouseEvent.ROLL_OVER, HandSlider, false, 0, true );
			}
			
			if( isVertical ){			
				if( isDecimal ){
					oneScale = true;
					percentage = false;
					precision = precis;
					t_cval.text = returnCurrValue( scaledHeight, posY, triangle.y, triangleH).toString();				
				}else{
					oneScale = false;
					percentage = true;
					precision = 0;
					t_cval.text = returnCurrValue( scaledHeight, posY, triangle.y, triangleH).toString();
				} 	
			}else{
				if( isDecimal ){
					oneScale = true;
					percentage = false;
					precision = precis;
					t_cval.text = returnCurrValue( scaledWidth, posX, triangle.x, triangleH).toString();				
				}else{
					oneScale = false;
					percentage = true;
					precision = 0;
					t_cval.text = returnCurrValue( scaledWidth, posX, triangle.x, triangleH).toString();
				}
			}
			
			dic[this] = { w:w, h:h, posX:posX, posY:posY, l_h:l_h, l_w:l_w, click:true, delta:0, triangleH:triangleH,
						  deltaScale:deltaScale, isVertical:isVertical, cVal:cVal, tmp_triangleH:tmp_triangleH }
		}
		
		private var oneScale:Boolean;
		private var percentage:Boolean;
		private var precision:Number;
		private var cVal_scale:Number;
		
		private function returnCurrValue( scale:Number, poS:Number, curPos:Number, triangleH:Number ):String
		{
			var fulPerc_sliderPos:Number;
			var s:Number;
			var s_ret:String;
			
				if( oneScale )
				{
					//scale 0-1				
					//scale position on slider to % value
					fulPerc_sliderPos = ( (curPos - poS + triangleH/2 ) / scale );
					cVal_scale = fulPerc_sliderPos;				
					//calculate proper % value depending on MAX value
					curVal = ( (fulPerc_sliderPos * s_max) / 100 ); // ( posX - curPos + (triangleH/2) );				
					if( curVal < .0 ) curVal = .0;
					s = s_max / 100;
					if( curVal > s ) curVal = s;	
					s_ret = curVal.toFixed( precision );
				}
				
				if( percentage )
				{
					//scale 0-100
					fulPerc_sliderPos = ( (curPos - poS + triangleH/2 ) / scale );
					curVal = ( fulPerc_sliderPos * s_max);				
					if( curVal < 0 ) curVal = 0;
					s = s_max * 100;
					if( curVal > s ) curVal = s;
					s_ret = Math.round( curVal).toString();
				}
			
			curVal = int(s_ret);
			return s_ret;
		}
				
	//---- move slider
		private var slider_Movable:Boolean = false;	
			
		private function can_moveSlider( evt:MouseEvent ):void
		{
			var posX:Number = dic[this].posX;
			var posY:Number = dic[this].posY;
			var tmp_triangleH:Number = dic[this].tmp_triangleH;
			var isVertical:Boolean = dic[this].isVertical;
			var c_size:Number = 8;
			
			if( isVertical ){
				l_circle.graphics.clear();
				l_circle.graphics.beginFill( 0x36d00d, 1 );
				l_circle.graphics.drawCircle( posX, posY - tmp_triangleH/2, c_size );
				l_circle.graphics.endFill();
			}else{
				l_circle.graphics.clear();
				l_circle.graphics.beginFill( 0x36d00d, 1 );
				l_circle.graphics.drawCircle( posX - tmp_triangleH/2, posY, c_size );
				l_circle.graphics.endFill();
			}
			
			slider_Movable = true;
						
			//change displayIndex to prevent other instances to overlap or fire up they listeners
			this.parent.setChildIndex( this, this.parent.numChildren-1 );
		}
				
		private function moveSlider( evt:MouseEvent ):void
		{
			if(slider_Movable)
			{
				var posX:Number = dic[this].posX;
				var posY:Number = dic[this].posY;
				var triangleH:Number = dic[this].triangleH;
				var isVertical:Boolean = dic[this].isVertical;
			
				if( isVertical ){
									
					this.x = this.parent.mouseX - posX ; 
					this.y = this.parent.mouseY - posY + triangleH/2;
					
				}else{
					//horizontal
					this.x = this.parent.mouseX - posX + triangleH/2;
					this.y = this.parent.mouseY - posY;	
									
				}
			}						
		}
		
		private function notMovableSlider( evt:MouseEvent ):void
		{
			var posX:Number = dic[this].posX;
			var posY:Number = dic[this].posY;
			var tmp_triangleH:Number = dic[this].tmp_triangleH;
			var isVertical:Boolean = dic[this].isVertical;
			
			if( isVertical ){	
				l_circle.graphics.clear();				
				l_circle.graphics.beginFill( 0x3c3737, 1 );
				l_circle.graphics.drawCircle( posX, posY - tmp_triangleH/2, 5 );
				l_circle.graphics.endFill();
			}else{
				l_circle.graphics.clear();
				l_circle.graphics.beginFill( 0x3c3737, 1 );
				l_circle.graphics.drawCircle( posX - tmp_triangleH/2, posY, 5 );
				l_circle.graphics.endFill();
			}
			slider_Movable = false;
		}
		
	//---- end move slider
	//---- scale slider
		private var scalable:Boolean = false;
		
		private function can_ScaleSlider( evt:MouseEvent ):void
		{	
			var posX:Number = dic[this].posX;
			var posY:Number = dic[this].posY;
			var w:Number = dic[this].w;
			var h:Number = dic[this].h;
			var triangleH:Number = dic[this].triangleH;
			var isVertical:Boolean = dic[this].isVertical;
			var c_size:Number = 8;
			
			if( triangleH < 20 ) triangleH = dic[this].tmp_triangleH;
			
			if( isVertical ){
						
				r_circle.graphics.clear();
				r_circle.graphics.beginFill( 0x142ace, 1 );
				r_circle.graphics.drawCircle( posX, posY + triangleH / 2 + h, c_size );
				r_circle.graphics.endFill();
				
			}else{
				
				r_circle.graphics.clear();
				r_circle.graphics.beginFill( 0x142ace, 1 );
				r_circle.graphics.drawCircle( posX + w + triangleH / 2, posY, c_size );
				r_circle.graphics.endFill();
			}
			
			scalable = true;
			
			//change displayIndex to prevent other instances to overlap or fire up they listeners
			this.parent.setChildIndex( this, this.parent.numChildren-1 );
		}
		
		private function scaleSlider( evt:MouseEvent ):void
		{
			if( scalable )
			{
				var posX:Number = dic[this].posX;
				var posY:Number = dic[this].posY;
				var w:Number = dic[this].w;
				var h:Number = dic[this].h;
				var triangleH:Number = dic[this].triangleH;
				var isVertical:Boolean = dic[this].isVertical;
				
				if( isVertical ){
					scaledHeight = this.mouseY - posY - triangleH/2;
					dic[this].l_h = l_h = scaledHeight;
					
					if( ( scaledHeight >= 0 ) ){
											
						line.graphics.clear()
						line.graphics.beginFill( 0x898989, 1 );
						line.graphics.drawRect( posX-w/2, posY, w, scaledHeight );
						line.graphics.endFill();
									
						r_circle.y = scaledHeight - h;				
						t_max_val.y = scaledHeight + posY;				
									
						if( oneScale )
						{
							//scale 0 - 1
							triangle.y = posY + ( ( scaledHeight * cVal_scale ) ) - triangleH/2;
							
						}
						
						if( percentage )
						{
							// scale 0 - 100
							triangle.y = ( (scaledHeight * curVal) / s_max) + posY - triangleH/2;										
						}
						
						t_cval.y = (triangle.y);
					
					}	
				
				}else{
					//horizontal
					scaledWidth = this.mouseX - posX - triangleH/2;
					dic[this].l_w = l_w = scaledWidth;
						
					if( ( scaledWidth >= 0 ) ){
											
						line.graphics.clear()
						line.graphics.beginFill( 0x898989, 1 );
						line.graphics.drawRect( posX, posY-h/2, scaledWidth, h );
						line.graphics.endFill();
									
						r_circle.x = scaledWidth - w;				
						t_max_val.x = scaledWidth + posX;				
									
						if( oneScale )
						{
							//scale 0 - 1
							triangle.x = posX + ( ( scaledWidth * cVal_scale ) ) - triangleH/2;
							
						}
						
						if( percentage )
						{
							// scale 0 - 100
							triangle.x = ( (scaledWidth * curVal) / s_max) + posX - triangleH/2;										
						}
						
						t_cval.x = (triangle.x);
						
					}
				}
			}	

		}
		
		private function notScalableSlider( evt:MouseEvent ):void
		{
			var posX:Number = dic[this].posX;
			var posY:Number = dic[this].posY;
			var w:Number = dic[this].w;
			var h:Number = dic[this].h;
			var triangleH:Number = dic[this].triangleH;
			var isVertical:Boolean = dic[this].isVertical;
			var c_size:Number = 5;
			
			if( triangleH < 20 ) triangleH = dic[this].tmp_triangleH;
			
			if( isVertical ){
				r_circle.graphics.clear();
				r_circle.graphics.beginFill( 0x474747, 1 );
				r_circle.graphics.drawCircle( posX, (posY + h + triangleH / 2), c_size );
				r_circle.graphics.endFill();
			}else{
				r_circle.graphics.clear();
				r_circle.graphics.beginFill( 0x474747, 1 );
				r_circle.graphics.drawCircle( (posX + w + triangleH / 2), posY, c_size );
				r_circle.graphics.endFill();
			}
			
			scalable = false;
		}
		
		private function HandSlider( evt:MouseEvent ):void
		{
			this.buttonMode = true;
		}
	//---- end scale slider		
	//---- triangle pointer move
		private function movableTriang( evt:MouseEvent ):void
		{
			tr_movable = true;
		}
		
		private function notmovableTriang( evt:MouseEvent ):void
		{
			tr_movable = false;
		}
		
		private function doMoveTriangle( evt:MouseEvent ):void
		{
			if( tr_movable )
			{ 
				var w:Number = dic[this].w;
				var h:Number = dic[this].h;
				var posX:Number = dic[this].posX;
				var posY:Number = dic[this].posY;
				var triangleH:Number = dic[this].triangleH;
				var isVertical:Boolean = dic[this].isVertical;
				
				if( isVertical ){
						if( (triangle.y >= (posY - triangleH/2) ) && ( (triangle.y <= (posY + scaledHeight) - triangleH/2) ) )
						{	
							triangle.y = mouseY - triangleH/2;	
							t_cval.y = triangle.y;	
							
							if(oneScale){
								t_cval.text = ( returnCurrValue( scaledHeight, posY, triangle.y, triangleH) );
							}else{
								t_cval.text = ( returnCurrValue( scaledHeight, posY, triangle.y, triangleH) ).toString();
							}	
						}
						
						if( (triangle.y < (posY - triangleH/2) ) ){
							triangle.y = posY - triangleH/2;
							t_cval.y = triangle.y;
								
							if(oneScale){
								t_cval.text = ( returnCurrValue( scaledHeight, posY, triangle.y, triangleH) ).toString();
							}else{
								t_cval.text = ( returnCurrValue( scaledHeight, posY, triangle.y, triangleH) ).toString();
							}
						}
						
						if( (triangle.y > (posY + scaledHeight) - triangleH/2 ) ){
							triangle.y = (posY + scaledHeight) - triangleH/2;
							t_cval.y = triangle.y;	
							
							if(oneScale){
								t_cval.text = ( returnCurrValue( scaledHeight, posY, triangle.y, triangleH) ).toString();
							}else{
								t_cval.text = ( returnCurrValue( scaledHeight, posY, triangle.y, triangleH) ).toString();
							}
						} 
					
				}else{
					//horizontal
						if( (triangle.x >= (posX - triangleH/2) ) && ( (triangle.x <= (posX + scaledWidth) - triangleH/2) ) )
						{			
							triangle.x = mouseX - triangleH/2;	
							t_cval.x = triangle.x;	
							
							if(oneScale){
								t_cval.text = ( returnCurrValue( scaledWidth, posX, triangle.x, triangleH) );
							}else{
								t_cval.text = ( returnCurrValue( scaledWidth, posX, triangle.x, triangleH) ).toString();
							}				
						}
						
						if( (triangle.x < (posX - triangleH/2) ) ){
							triangle.x = posX - triangleH/2;
							t_cval.x = triangle.x;
								
							if(oneScale){
								t_cval.text = ( returnCurrValue( scaledWidth, posX, triangle.x, triangleH) ).toString();
							}else{
								t_cval.text = ( returnCurrValue( scaledWidth, posX, triangle.x, triangleH) ).toString();
							}
						}
						
						if( (triangle.x > (posX + scaledWidth) - triangleH/2 ) ){
							triangle.x = (posX + scaledWidth) - triangleH/2;
							t_cval.x = triangle.x;	
							
							if(oneScale){
								t_cval.text = ( returnCurrValue( scaledWidth, posX, triangle.x, triangleH) ).toString();
							}else{
								t_cval.text = ( returnCurrValue( scaledWidth, posX, triangle.x, triangleH) ).toString();
							}
						} 
				}
			}
		}
		
		private function moveTriangle( evt:MouseEvent ):void					
		{
			var w:Number = dic[this].w;
			var h:Number = dic[this].h;
			var posX:Number = dic[this].posX;
			var posY:Number = dic[this].posY;
			
			var isVertical:Boolean = dic[this].isVertical;
			var deltaScale:Number = dic[this].deltaScale;
			var triangleH:Number = dic[this].triangleH;
				
			var delta:Number			
			var click:Boolean;
			if( evt.type == "click" ){ 
				click = true;
			}else{
				click = false;
				delta = evt.delta;
			}
			
			
			if( isVertical ){	
				if(click){		
					if(!tr_movable){
						if( (triangle.y >= posY) && (triangle.y <= (posY + h) ) )
						{ 
							if(mouseY < triangle.y){
								triangle.y -= 1;
								t_cval.y = triangle.y;
								
								if(oneScale){
									t_cval.text = ( returnCurrValue( scaledWidth, posX, triangle.y, triangleH) );
								}else{
									t_cval.text = ( returnCurrValue( scaledWidth, posX, triangle.y, triangleH) );
								}
								
							}else{
								triangle.y += 1;	
								t_cval.y = triangle.y;
								
								if(oneScale){
									t_cval.text = ( returnCurrValue( scaledWidth, posX, triangle.y, triangleH) );
								}else{
									t_cval.text = ( returnCurrValue( scaledWidth, posX, triangle.y, triangleH) );
								}
							}
						}
					}
				}else{
					if( (triangle.y >= posY) && (triangle.y <= (posY + h)-10 ) )
					{
						if( delta ){
									triangle.y -= delta*deltaScale;
									t_cval.y = triangle.y;
									
									if(oneScale){
										t_cval.text = ( returnCurrValue( scaledWidth, posX, triangle.y, triangleH) );
									}else{
										t_cval.text = ( returnCurrValue( scaledWidth, posX, triangle.y, triangleH) );
									}
						}else{
									triangle.y += delta*deltaScale;
									t_cval.y = triangle.y;
									
									if(oneScale){
										t_cval.text = ( returnCurrValue( scaledWidth, posX, triangle.y, triangleH) );
									}else{
										t_cval.text = ( returnCurrValue( scaledWidth, posX, triangle.y, triangleH) );
									}
						}
					}else{
						if( (triangle.y <= posY) )
						{
								triangle.y = posY;
								t_cval.y = triangle.y;
								
								if(oneScale){
									t_cval.text = ( returnCurrValue( scaledWidth, posX, triangle.y, triangleH) );
								}else{
									t_cval.text = ( returnCurrValue( scaledWidth, posX, triangle.y, triangleH) );
								}					 
						}
						if( (triangle.y >= (posY + h)-10) )
						{
								triangle.y = (posX + h)-10;
								t_cval.y = triangle.x;
								
								if(oneScale){
									t_cval.text = ( returnCurrValue( scaledWidth, posX, triangle.y, triangleH) );
								}else{
									t_cval.text = ( returnCurrValue( scaledWidth, posX, triangle.y, triangleH) );
								}							
						}
					}
				}
			}else{
				//horizontal
				if(click){		
					if(!tr_movable){
						if( (triangle.x >= posX) && (triangle.x <= (posX + w) ) )
						{ 
							if(mouseX < triangle.x){
								triangle.x -= 1;
								t_cval.x = triangle.x;
								
								if(oneScale){
									t_cval.text = ( returnCurrValue( scaledWidth, posX, triangle.x, triangleH) );
								}else{
									t_cval.text = ( returnCurrValue( scaledWidth, posX, triangle.x, triangleH) );
								}
								
							}else{
								triangle.x += 1;	
								t_cval.x = triangle.x;
								
								if(oneScale){
									t_cval.text = ( returnCurrValue( scaledWidth, posX, triangle.x, triangleH) );
								}else{
									t_cval.text = ( returnCurrValue( scaledWidth, posX, triangle.x, triangleH) );
								}
							}
						}
					}
				}else{
					if( (triangle.x >= posX) && (triangle.x <= (posX + w)-10 ) )
					{
						if( delta ){
									triangle.x += delta*deltaScale;
									t_cval.x = triangle.x;
									
									if(oneScale){
										t_cval.text = ( returnCurrValue( scaledWidth, posX, triangle.x, triangleH) );
									}else{
										t_cval.text = ( returnCurrValue( scaledWidth, posX, triangle.x, triangleH) );
									}
						}else{
									triangle.x -= delta*deltaScale;
									t_cval.x = triangle.x;
									
									if(oneScale){
										t_cval.text = ( returnCurrValue( scaledWidth, posX, triangle.x, triangleH) );
									}else{
										t_cval.text = ( returnCurrValue( scaledWidth, posX, triangle.x, triangleH) );
									}
						}
					}else{
						if( (triangle.x <= posX) )
						{
								triangle.x = posX;
								t_cval.x = triangle.x;
								
								if(oneScale){
									t_cval.text = ( returnCurrValue( scaledWidth, posX, triangle.x, triangleH) );
								}else{
									t_cval.text = ( returnCurrValue( scaledWidth, posX, triangle.x, triangleH) );
								}					 
						}
						if( (triangle.x >= (posX + w)-10) )
						{
								triangle.x = (posX + w)-10;
								t_cval.x = triangle.x;
								
								if(oneScale){
									t_cval.text = ( returnCurrValue( scaledWidth, posX, triangle.x, triangleH) );
								}else{
									t_cval.text = ( returnCurrValue( scaledWidth, posX, triangle.x, triangleH) );
								}							
						}
					}
				}
			}
		}
		
		private function moveTriangleBGpaint( evt:MouseEvent ):void
		{
			var w:Number = dic[this].l_w;
			var h:Number = dic[this].l_h;
			var posX:Number = dic[this].posX;
			var posY:Number = dic[this].posY;
			var isVertical:Boolean = dic[this].isVertical; 
			
			if( isVertical ){
				line_bg.graphics.clear();
				line_bg.graphics.beginFill( 0x000000, .1 );
				line_bg.graphics.drawRect( posX-2, posY, w+4, h );
				line_bg.graphics.endFill();
				line.addChild( line_bg );
			}else{
				line_bg.graphics.clear();
				line_bg.graphics.beginFill( 0x000000, .1 );
				line_bg.graphics.drawRect( posX, posY-2, w, h+4 );
				line_bg.graphics.endFill();
				line.addChild( line_bg );
			}	
			
		}
		
		private function moveTriangleBGerase( evt:MouseEvent ):void
		{
			line.removeChild( line_bg );
		}
		
		private var triangle_shadow:Shape = new Shape();
		private function overTriangle( evt:MouseEvent ):void
		{	
			var triangleH:Number = dic[this].triangleH;
			
			triangle.buttonMode = true;
			triangle.graphics.clear();
			triangle.graphics.beginFill(0x0f0f0f);
			triangle.graphics.moveTo(triangleH/2, 5);
			triangle.graphics.lineTo(triangleH, triangleH+5);
			triangle.graphics.lineTo(0, triangleH+5);
			triangle.graphics.lineTo(triangleH/2, 5);
			
			
			var s_triangleH:Number = triangleH+6;
			triangle_shadow.graphics.clear();
			triangle_shadow.graphics.beginFill(0xaeaeae);
			triangle_shadow.graphics.moveTo(s_triangleH/2, 5);
			triangle_shadow.graphics.lineTo(s_triangleH, s_triangleH+5);
			triangle_shadow.graphics.lineTo(0, s_triangleH+5);
			triangle_shadow.graphics.lineTo(s_triangleH/2, 5);
			triangle_shadow.x = -3;
			triangle_shadow.y = -3;
			triangle_shadow.alpha = .5;
			triangle.addChild( triangle_shadow );		
			
			tr_movable = false;
		}
		
		private function outTriangle( evt:MouseEvent ):void
		{
			var triangleH:Number = dic[this].triangleH;
				
			triangle.graphics.clear();
			triangle.graphics.beginFill(0x595d6a);
			triangle.graphics.moveTo(triangleH/2, 5);
			triangle.graphics.lineTo(triangleH, triangleH+5);
			triangle.graphics.lineTo(0, triangleH+5);
			triangle.graphics.lineTo(triangleH/2, 5);
						
			triangle.removeChild( triangle_shadow );			
						
			tr_movable = false;
		}
	}
}